config/routes.rb
Rails.application.routes.draw do
  devise_for :users, controllers: {
    sessions: 'users/sessions',
    registrations: 'users/registrations'
  }
  resources :couples, except: [:index, :new]
  resources :verification_codes
  resources :scores, except: [:index]
  resources :match_players, except: [:new, :index, :edit]
  resources :matches, except: [:index, :destroy, :edit]
  resources :events
  
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Defines the root path route ("/")
  root "events#dashboard"

  # route for a new match-player with a specific event
  get 'match_players/new/:id', to: "match_players#new", as: 'new_match_player'
  get "match_players/edit/:id/(:resend)", to: "match_players#edit", as: "edit_match_player"
  # route to show the players for a specific event
  get 'match_players/index/:id', to: "match_players#index", as: 'players_enrolled'

  
  
  get 'matches/index/:id/(:round)', to: "matches#index", as: 'event_matches'
  get 'matches/player_matches/:event_id/:player_id', to: "matches#player_matches", as: 'player_matches'
  delete "matches/:event_id/:round", to: "matches#destroy", as: "matches_destroy_round"
  get 'matches/create_round_of_matches/:event_id', to: "matches#create_round_of_matches", as: 'create_round_of_matches'
  
  patch "events/update_status/:id", to: "events#update_status", as: "update_status_event"
  get "event/show_closed_event/:id", to: "events#show_closed_event", as: "show_closed_event"
  get "matches/edit/:id/:round", to: "matches#edit", as: "edit_match"
  get "scores/index/:id", to: "scores#index", as: "player_scores"
  
  get "players/new/(:event_id)", to: "players#new", as: "new_player"
  resources :players, except: [:new]
  
  #resources :players do
  #  get "players/new/(:event_id)", to: "players#new", as: "new_player", on: :collection
  #end
  
  get 'couples/index/:id', to: "couples#index", as: 'event_couples'
  get "couples/new/:id", to: "couples#new", as: "new_couple"
  get "players/dashboard/:player_id", to:  "players#dashboard", as: "dashboard_player"
  get "events/dashboard", to: "events#dashboard", as: "dashboard_events"
  #comment x
end 

app/models/couple.rb
class Couple < ApplicationRecord
  belongs_to :event
  belongs_to :player
  belongs_to :mate, class_name: "Player"
  #has_many :datosgenerales, :through => :agenda_accounts
end

app/controllers/couples_controller.rb
class CouplesController < ApplicationController
  before_action :set_couple, only: %i[ show edit update destroy ]

  # GET /couples or /couples.json
  def index
    @couples = Couple.where(event_id: params[:id])
    @event = Event.find(params[:id])
  end

  # GET /couples/1 or /couples/1.json
  def show
  end

  # GET /couples/new
  def new
    @couple = Couple.new
    @couple.event_id = params[:id]
    @players_to_mate = Player.ready_to_mate(params[:id])
  end

  # GET /couples/1/edit
  def edit
  end

  # POST /couples or /couples.json
  def create
    @couple = Couple.new(couple_params)
  
    respond_to do |format|
      if @couple.save
        format.html { redirect_to event_couples_url(@couple.event_id), notice: "Couple was successfully created." }
        format.json { render :show, status: :created, location: @couple }
      else
        @players_to_mate = Player.ready_to_mate(params[:event_id])
        format.html { render :new, locals: {couple: @couple}, status: :unprocessable_entity }
        format.json { render json: @couple.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /couples/1 or /couples/1.json
  def update
    respond_to do |format|
      if @couple.update(couple_params)
        format.html { redirect_to couple_url(@couple), notice: "Couple was successfully updated." }
        format.json { render :show, status: :ok, location: @couple }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @couple.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /couples/1 or /couples/1.json
  def destroy
    @couple.destroy

    respond_to do |format|
      format.html { redirect_to couples_url, notice: "Couple was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_couple
      @couple = Couple.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def couple_params
      params.require(:couple).permit(:player_id, :mate_id, :event_id)
    end
end

app/helpers/couples_helper.rb
module CouplesHelper
end

app/views/couples/_couple.html.erb
<div id="<%= dom_id couple %>">
</div>

app/views/couples/_form.html.erb
<div class="col-md-8">
  <div class="card"><!-- EVENT DETAILS -->
        <div class="card-header pb-0 p-3">
            <div class="d-flex align-items-center">
                <h5 class="mb-0 text-primary">New Couple for the event</h5>                  
                  <%= link_to(event_couples_path(couple.event_id), class:"btn btn-sm btn-primary ms-auto") do %>
                          Couple list&nbsp;&nbsp;<i class="fa fa-list"></i>
                        <%end%>         
            </div>            
        </div>
        <div class="card-body p-3">
            <div class="row">
                <div class="col-6">
                    <ul class="list-group">
                        <li class="list-group-item border-0 ps-0 pt-0 text-sm"><strong class="text-dark">Event Name:</strong> &nbsp; [<%= couple.event.id%>]&nbsp;<%= couple.event.name.titleize%>&nbsp;
                            <span class="badge badge-pill badge-lg bg-gradient-danger"><%="CLOSED" if  couple.event.status.upcase == "CLOSED"%></span>
                        </li>
                        <li class="list-group-item border-0 ps-0 text-sm"><strong class="text-dark">Date:</strong> &nbsp; <%=local_time( couple.event.created_at, %"%d/%m/%Y") %> at <%= couple.event.timeIni.strftime("%H:%M")%> - <%= couple.event.timeEnd.strftime("%H:%M")%></li>
                        <li class="list-group-item border-0 ps-0 text-sm"><strong class="text-dark">Couples:</strong> &nbsp; <%=( couple.event.mixed? ? "MIXED":"FIXED" ) %>&nbsp;
                              <strong class="text-dark">Category:</strong>&nbsp; <%= couple.event.level%>
                        </li>
                        
                    </ul>
                </div>                
            </div>
        </div>
    </div>
  </div>
    <div class="col-md-8">
        <br>
    </div>

<div class="row">
    <div class="col-md-8">
        <div class="card">                          
            <%= form_with(model: couple) do |f| %>
              <% if couple.errors.any? %>
                <div style="color: red">
                  <h2><%= pluralize(couple.errors.count, "error") %> prohibited this event from being saved:</h2>

                  <ul>
                    <% couple.errors.each do |error| %>
                      <li><%= error.full_message %></li>
                    <% end %>
                  </ul>
                </div>
              <% end %>

              <div class="card-body">                          
                  <div class="row">                      
                      <div class="col-md-8">
                          <div class="form-group">
                              <label for="example-text-input" class="form-control-label">Player 1</label>
                              <%= f.select :player_id, options_for_select(@players_to_mate.collect{ |player|
                                                                         [player.name << " - " << player.cellphone, player.id  ] }, couple.player_id), {}, {id: 'select2_player',class:"form-control m-b",  required: true} %>

                          </div>
                      </div>
                      <div class="col-md-8">
                          <div class="form-group">
                              <label for="example-text-input" class="form-control-label">Player 2</label>
                              <%= f.select :mate_id, options_for_select(@players_to_mate.collect { |player|
                                                                         [player.name  << " - " << player.cellphone, player.id] }, couple.mate_id), {}, {id: 'select2_mate',class:"form-control m-b",  required: true} %>
                          </div>
                      </div>
                      <%= f.hidden_field :event_id %>
                  </div>
                  <hr class="horizontal dark">
                  <div class="form-group">
                    <div class="col-sm-4 col-sm-offset-2">                      
                      <%= button_tag(type: 'submit', data: {turbo: false}, class: "btn bg-gradient-success ms-auto") do %>
                        Save&nbsp;&nbsp;<i class="fa fa-database"></i>
                      <% end %>
                    </div>
                  </div>
                  
              </div>
            <% end %>

        </div>
    </div>                
</div>
<script type="text/javascript">
  // In your Javascript (external .js resource or <script> tag)
  $(document).ready(function() {
      //$('.js-example-basic-single').select2();
      $('#select2_player').select2();
      $('#select2_mate').select2();
  });
</script>

app/views/couples/edit.html.erb
<h1>Editing couple</h1>

<%= render "form", couple: @couple %>

<br>

<div>
  <%= link_to "Show this couple", @couple %> |
  <%= link_to "Back to couples", couples_path %>
</div>

app/views/couples/index.html.erb
<div class="card"><!-- EVENT DETAILS -->
        <div class="card-header pb-0 p-3">
            <div class="d-flex align-items-center">
                <h5 class="mb-0 text-primary">Couples for the event</h5>                  
                  <div class="dropdown ms-auto">
                          <button type="button" class="btn bg-gradient-primary dropdown-toggle" data-bs-toggle="dropdown" aria-expanded="false">
                            Action
                          </button>
                          <ul class="dropdown-menu px-2 py-3" aria-labelledby="dropdownMenuButton">
                            <li>
                              <% if @event.try(:status).try(:upcase) != "CLOSED"%>                                
                                <%= link_to(new_couple_path(@event), class: "dropdown-item") do %>
                                  <i class="fa fa-plus-square"></i> New Couple
                                <%end%>
                              <%end%>
                            </li>                              
                            <li>                            
                            <%= link_to(players_enrolled_path(@event), class: "dropdown-item") do %>
                                  <i class="fa fa-users"></i> Event players
                                <%end%>
                            </li>
                          </ul>
                  </div>                
            </div>            
        </div>
        <div class="card-body p-3">
            <div class="row">
                <div class="col-6">
                    <ul class="list-group">
                        <li class="list-group-item border-0 ps-0 pt-0 text-sm"><strong class="text-dark">Event Name:</strong> &nbsp; [<%=@event.id%>]&nbsp;<%=@event.name.titleize%>&nbsp;
                            <span class="badge badge-pill badge-lg bg-gradient-danger"><%="CLOSED" if @event.status.upcase == "CLOSED"%></span>
                        </li>
                        <li class="list-group-item border-0 ps-0 text-sm"><strong class="text-dark">Date:</strong> &nbsp; <%=local_time(@event.created_at, %"%d/%m/%Y") %> at <%=@event.timeIni.strftime("%H:%M")%> - <%=@event.timeEnd.strftime("%H:%M")%></li>
                        <li class="list-group-item border-0 ps-0 text-sm"><strong class="text-dark">Couples:</strong> &nbsp; <%=(@event.mixed? ? "MIXED":"FIXED" ) %>&nbsp;
                              <strong class="text-dark">Category:</strong>&nbsp; <%=@event.level%>
                        </li>
                        
                    </ul>
                </div>                
            </div>
        </div>
    </div>
    
    <div class="col-md-12">
        <br>
    </div>
<div class="row">
  <div class="col-12">
    <div class="card mb-4">
    <div class="d-flex px-2 py-1">
    </div>
      
      <div class="card-body px-0 pt-0 pb-2">
        <div class="table-responsive p-0">
          <table class="table align-items-center mb-0">
            <thead>
              <tr>                      
                <th class="text-uppercase text-primary text-s font-weight-bolder ps-4">Couples</th>
                <th class="text-secondary opacity-7"></th>                      
              </tr>
            </thead>
            <tbody>
            <% @couples.each.with_index(1) do | couple, index |%>
              <tr>
                
                <td>                         
                  <div class="d-flex px-2 py-1">
                    <div >
                      <%if !couple.player.image_attachment.nil?%>
                        <%= image_tag(couple.player.image, class: "avatar avatar-sm me-3") if !couple.player.image_attachment.nil? %>
                      <%else%>
                        <%= image_tag("blank-profile-picture.jpg", class: "avatar avatar-sm me-3")%>
                      <%end%>                            
                    </div>
                    <div class="d-flex flex-column justify-content-center">
                      <h6 class="mb-0 text-sm"><%= link_to couple.player.name.titleize, couple, class: "text-xs font-weight-bold mb-0" %></h6>
                    </div>&nbsp;&nbsp;
                    <p class="h5"><span class="badge badge-pill bg-gradient-success">Couple&nbsp;<%=index%></span></p>&nbsp;&nbsp;
                    <div class="d-flex flex-column justify-content-center">
                      <h6 class="mb-0 text-sm"><%= link_to couple.mate.name.titleize, couple, class: "text-xs font-weight-bold mb-0" %></h6>
                    </div>&nbsp;&nbsp;                          
                    
                    <div >
                      <%if !couple.mate.image_attachment.nil?%>
                        <%= image_tag(couple.mate.image, class: "avatar avatar-sm me-3") if !couple.mate.image_attachment.nil? %>
                      <%else%>
                        <%= image_tag("blank-profile-picture.jpg", class: "avatar avatar-sm me-3")%>
                      <%end%>                            
                    </div>
                  </div>
                </td>                      
                <td class="d-flex px-2">
                  <%= link_to(couple, data: {turbo_method: :delete, turbo_confirm: 'Are you sure?'}, class:"btn btn-sm btn-danger ms-auto") do %>
                    Delete&nbsp;&nbsp;<i class="fa fa-trash-o"></i>
                  <%end%>
                  
                </td>                                            
              </tr>
              <%end%>
            </tbody>
          </table>
        </div>
      </div>
    </div>
  </div>
</div>

app/views/couples/new.html.erb
<%= render "form", couple: @couple %>

app/views/couples/show.html.erb
<p style="color: green"><%= notice %></p>

<%= render @couple %>

<div>
  <%= link_to "Edit this couple", edit_couple_path(@couple) %> |
  <%= link_to "Back to couples", couples_path %>

  <%= button_to "Destroy this couple", @couple, method: :delete %>
</div>